#include "KlappenAblauf.h"



KlappenAblauf::~KlappenAblauf()
{
}


statusKlappen KlappenAblauf::setOpen(bool open)
{
  if(aktuellerState == WARTE){
    if(open)
      aktuellerState = START_AUF;
    else
      aktuellerState = START_ZU;
  return OK;
  }

  return ERROR_BUSY;

}

statusKlappen  KlappenAblauf::setOpen(bool open , int id)
{ 
  KlappenAblauf *zeiger;
  zeiger = (KlappenAblauf *) searchIdElement(id);
  if(zeiger)
    return zeiger->setOpen(open);
  return ERROR_ID;
}

void KlappenAblauf::memberSetup(){
  AnalogDigital::memberSetup();
  fsmInit();
}

void KlappenAblauf::memberLoop(){
  AnalogDigital::memberLoop();
  fsmStep();
}

void KlappenAblauf::fsmInit(){
  aktuellerState = INIT;

}


void KlappenAblauf::fsmStep(){

  switch (aktuellerState)
  {
  case INIT:
    aktuellerState = WARTE;
    break;

  case WARTE:
    break;

  case START_AUF:
    setMotorAktion(1);
    timer = 5000;
    aktuellerState = FAEHRT;
    break;

  case START_ZU:
    setMotorAktion(-1);
    timer = 5000;
    aktuellerState = FAEHRT;
    break;

  case FAEHRT:
    timer -= getDeltamsec();
    if(timer <= 0){
      setMotorAktion(0);
      aktuellerState = FERTIG;
    }
    break;

  case FERTIG:
    aktuellerState = WARTE;
    break;

  default:
    aktuellerState = INIT;
    break;
  }

}
