
#ifndef KLAPPENABLAUF_H
#define KLAPPENABLAUF_H

#include "statusKlappen.h"
#include "analogDigital.h"

/**
  * class KlappenAblauf
  * 
  */

class KlappenAblauf : public AnalogDigital
{
public:
  // Constructors/Destructors
  //  


  /**
   * Empty Constructor
   */
  //KlappenAblauf();

  /**
   * Empty Destructor
   */
  virtual ~KlappenAblauf();

  // Static Public attributes
  //  

  // Public attributes
  //

   /**
   * @param  open
   */
  statusKlappen setOpen(bool open);
  static statusKlappen setOpen(bool open , int id);

protected:

  void memberSetup();
  void memberLoop();

  // Static Protected attributes
  //  

  // Protected attributes
  //

private:

  int16_t timer;
  typedef enum fsmStatesEnum{
    INIT,
    WARTE,
    START_AUF,
    START_ZU,
    FAEHRT,
    FERTIG,

  }fsmStates;
  
  fsmStates aktuellerState;

  void fsmInit();
  void fsmStep();


};

#endif // KLAPPENABLAUF_H
